﻿Option Strict On
Imports Microsoft.Reporting.WinForms
Imports System.IO
'
Public Class BerichtsVerwaltung
    Dim Berichte As New List(Of String) From {{"1 Zeilengruppe als Block mit Teilergebnis unterhalb"},
                                                            {"1 Zeilengruppe als Block mit Teilergebnis oberhalb"},
                                                            {"1 Zeilengruppe abgestuft mit Teilergebnis oberhalb"},
                                                            {"1 Zeilengruppe abgestuft mit Teilergebnis oberhalb und Interaktion"},
                                                            {"2 Zeilengruppen als Block mit Teilergebnis unterhalb"},
                                                            {"2 Zeilengruppen als Block mit Teilergebnis oberhalb"},
                                                            {"2 Zeilengruppen als Block mit Teilergebnis unterhalb und Interaktion"},
                                                            {"2 Zeilengruppen als Block mit Teilergebnis oberhalb und Interaktion"},
                                                            {"1 Spaltengruppe mit 1 Wert"},
                                                            {"1 Spaltengruppe mit 2 Werte"},
                                                            {"2 Spaltengruppen mit 2 Werte"},
                                                            {"2 Spaltengruppen mit 2 Werte und Interaktion"},
                                                            {"manuelles Beispiel"}}
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.DtsNordwind.ReadXml("..\..\Nordwind.xml")
        cbxBerichte.Items.AddRange(Berichte.ToArray) ' hier sämtliche Berichte angeben...
        cbxBerichte.SelectedIndex = 0 ' den ersten Bericht zur Anzeige bringen
    End Sub

    Private Sub cbx_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) _
        Handles cbxBerichte.SelectedIndexChanged
        Dim Bericht As String = getItem(Me.cbxBerichte)
        Select Case True
            Case sender Is cbxBerichte
                Select Case Bericht
                    Case Is = "1 Zeilengruppe als Block mit Teilergebnis unterhalb" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "1 Zeilengruppe als Block mit Teilergebnis oberhalb" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "1 Zeilengruppe abgestuft mit Teilergebnis oberhalb" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "1 Zeilengruppe abgestuft mit Teilergebnis oberhalb und Interaktion" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "2 Zeilengruppen als Block mit Teilergebnis unterhalb" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "2 Zeilengruppen als Block mit Teilergebnis oberhalb" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "2 Zeilengruppen als Block mit Teilergebnis unterhalb und Interaktion" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "2 Zeilengruppen als Block mit Teilergebnis oberhalb und Interaktion" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "1 Spaltengruppe mit 1 Wert" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "1 Spaltengruppe mit 2 Werte" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "2 Spaltengruppen mit 2 Werte" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "2 Spaltengruppen mit 2 Werte und Interaktion" : bindReport(Bericht, DtsNordwind.Bestellungen)
                    Case Is = "manuelles Beispiel" : bindReport(Bericht, DtsNordwind.Bestellungen)
                End Select
        End Select
    End Sub

    Private Sub bindReport(BerichtName As String, Datasource As Object)
        Dim rds As ReportDataSource = New ReportDataSource()
        rds.Name = "DataSet1" 'Name der Berichtsdatenquelle (ist auch Teil des Reportnamens)
        rds.Value = Datasource
        With Me.prtReportViewer
            .LocalReport.DataSources.Clear()
            .LocalReport.DataSources.Add(rds)
            .LocalReport.ReportEmbeddedResource = String.Concat("ReportViewerTutorial.Report ", BerichtName, ".rdlc") 'in Resource eingebetteter Bericht
            .RefreshReport()
        End With
    End Sub

    Private Function getItem(cbx As ComboBox) As String
        If cbx.SelectedItem Is Nothing Then Return String.Empty Else Return cbx.SelectedItem.ToString
    End Function

End Class